<?php

class onLanguagesContentBeforeAdd extends cmsAction {

    public function run($item){
	
		$langs = cmsCore::getLanguages();
  		$system_lang = cmsCore::getLanguageName();
		$config_lang = cmsConfig::getInstance()->language;
		$options = $this->getOptions();
	
		$url = explode('/', $this->cms_core->uri);
		$table = 'languages_con_'.$url[0];
		$exists_fields = $this->model->db->getTableFields($table);
		unset($exists_fields[0]);
		unset($exists_fields[1]);		
		unset($exists_fields[2]);		
		unset($exists_fields[3]);

		$user = cmsUser::getInstance();
		$allow = false;
		$is_moderator = false;	
		
		if(isset($data['ctype_id'])) {
			$content_model = cmsCore::getModel('content');										
			$ctype = $content_model->getContentType($item['ctype_id']);
			$is_moderator =  cmsCore::getModel('content')->userIsContentTypeModerator($item['ctype_name'], $user->id);				
		}		

		if(($user->is_admin || $is_moderator) && $options['forms_admin'] == 1) $allow = true;
		if($user->is_logged && $options['forms_user'] == 1) $allow = true;
		if(!$user->is_logged && $options['forms_guest'] == 1) $allow = true;

		# если контроль форм выключен
		if($allow == false){
		//echo 'manual';
			# если язык пользователя соответствует языку сайта
			if($system_lang == $config_lang){
				foreach($item as $key=>$value){
					if(in_array($key, $exists_fields)){
						foreach($langs as $lang){	
							if($lang != $config_lang && empty($item[$key.'_'.$lang])) {
								if($options['autotranslate']){
									$response = $this->model->TranslateItem($value, $lang, $options['yandex_key']);
								} else {
									$response = $value;
								}
								if($response) $item[$key.'_'.$lang] = $response;							
							}
						}
					}
				}
			}
			
			# если язык пользователя не соответствует языку сайта
			if($system_lang != $config_lang){		
				foreach($item as $key=>$value){	
				
					foreach($langs as $lang){
						// другие языки
						if(in_array($key, $exists_fields)){
							if($lang != $config_lang && $lang != $system_lang && empty($item[$key.'_'.$lang])){
								if($options['autotranslate']){
									$response = $this->model->TranslateItem($value, $lang, $options['yandex_key']);
								} else {
									$response = $value;
								}
								if($response) $item[$key.'_'.$lang] = $response;
							}
						}
						// язык пользователя
						if(in_array($key, $exists_fields)){
							if($lang != $config_lang && $lang == $system_lang && empty($item[$key.'_'.$lang])){
								if($options['autotranslate']){
									$response = $this->model->TranslateItem($value, $lang, $options['yandex_key']);
								} else {
									$response = $value;
								}
								if($response) $item[$key.'_'.$lang] = $response;
							}								
						}
						
						#
						if(in_array($key, $exists_fields) && !empty($value) && $options['autotranslate']){
							$response = $this->model->TranslateItem($value, $config_lang, $options['yandex_key']);
							if($response) $item[$key] = $response;
							
							
						}
					}
				}
			}
		
		
		}
		










	

		foreach($item as $key=>$val){
			$field_lang = explode('_', $key);
			$field_lang = $field_lang[count($field_lang)-1];
			
			# переносим оригинальные поля в отдельный массив
			if(!in_array($field_lang, $langs)){
				$translate['original'][$key] = $item[$key];
				unset($item[$key]);									
			}
			# переносим оригинальные поля в отдельный массив
			
			# формируем массивы с переводами
			foreach($langs as $lang){
				if(isset($item[$key.'_'.$lang])){
					if(empty($translate[$lang][$key])) $translate[$lang][$key] = $item[$key.'_'.$lang];
					unset($item[$key.'_'.$lang]);										
				}
			}
			# формируем массивы с переводами
	
	
		}

		$item = array_merge($item, $translate['original']);
		unset($translate['original']);	


		$url = explode('/', $this->cms_core->uri);
		$table = 'con_'.$url[0];
		
		foreach($translate as $key=>$tr){
			# если для поля отсутствует перевод берем оригинал текста
			foreach($tr as $k=>$value){
				if(empty($value)) $tr[$k] = $item[$k];
				if(empty($tr[$k]) && isset($translate[$system_lang][$k])) $tr[$k] = $translate[$system_lang][$k];				
			}
			$tr['item_id'] = 0;
			$tr['ctype'] = $url[0];
			$tr['lang'] = $key;
			
			if($options['autotranslate']) {
				if(isset($item['seo_title'])) $tr['seo_title'] = $this->model->TranslateItem($item['seo_title'], $key, $options['yandex_key']);				
				if(isset($item['seo_keys'])) $tr['seo_keys'] = $this->model->TranslateItem($item['seo_keys'], $key, $options['yandex_key']);
				if(isset($item['seo_desc'])) $tr['seo_desc'] = $this->model->TranslateItem($item['seo_desc'], $key, $options['yandex_key']);
			} else {
				if(isset($item['seo_title'])) $tr['seo_title'] = $item['seo_title'];
				if(isset($item['seo_keys'])) $tr['seo_keys'] = $item['seo_keys'];
				if(isset($item['seo_desc'])) $tr['seo_desc'] = $item['seo_desc'];					
			}

			$this->model->insert('languages_'.$table, $tr);
		}
		 
		if($options['autotranslate_tags']) {	
			if(isset($item['tags']) && !empty($item['tags'])) {
				$tags = array();	
				foreach($langs as $lang){
					$item['tags'] = str_replace(',', '||', $item['tags']);
					$resp = mb_strtolower($this->model->TranslateItem($item['tags'], $lang, $options['yandex_key']));
					if($resp) $tags[$lang] = explode('||', $resp);
											
				}
				if($tags) $this->model->WriteTags($tags, $langs, $config_lang);
				$item['tags'] = implode(', ', $tags[$config_lang]);				
			}

		}


	
		//echo '<pre>';print_r($item);echo '</pre>';
		
        return $item;

    }

}