<?php

class onLanguagesMenuContent extends cmsAction {

    public function run($item){

		$lang = cmsCore::getLanguageName();

        if ($item['url'] == '#'){					
			if($lang !== $this->cms_config->language){
				$this->model->selectOnly('i.id, i.labels, i.item_id');
				$labels = $this->model->filterEqual('lang', $lang)->get('languages_ctypes', function($item, $model){
					$item['labels'] = cmsModel::yamlToArray($item['labels']);
					return $item;
				});

				if ($labels) {
					foreach($labels as $label){
						for($i = 0; $i < count($item['items']); $i++){										
							if($item['items'][$i]['id'] == 'content_add' . $label['item_id']){
								$item['items'][$i]['title'] = sprintf(LANG_CONTENT_ADD_ITEM, $label['labels']['create']);
								continue;
							}
						}					
					}
				}
			}

        } else {
			if ($lang !== $this->cms_config->language) {
				$segments = explode('/', mb_substr($item['url'], 1));
				if (!empty($segments[0])) {			
					$is_lang = is_dir($this->cms_config->root_path.'system/languages/'.$segments[0].'/');
					if (preg_match('/^[a-z]{2}$/i', $segments[0]) && $is_lang && isset($segments[1])){
						$ctype_name = $segments[1];
					} else {
						$ctype_name = $segments[0];
					}
					
					$this->model->selectOnly('i.id, i.title, i.item_id')->filterEqual('i.ctype', $ctype_name);
					$cats = $this->model->filterEqual('lang', $lang)->get('languages_cats');

					if($cats){

						foreach($cats as $cat){
							for($i = 0;$i < count($item['items']); $i++){
								if($item['items'][$i]['id'] == 'content.' . $ctype_name . '.' .$cat['item_id']){								
									$item['items'][$i]['title'] = $cat['title'];
									continue;
								}

							}
							
						}

					}

				}

			}
			
        }

		return $item;

    }

}